--
-- template: pg_selector
--
-- <DELAY=1>
--
-- <$w1>-bit 2-way selector
--
--
library ieee;
use ieee.std_logic_1164.all;

entity <$mname> is
  port (cond   : in  std_logic;
        srca   : in  std_logic_vector(<$w2-1> downto 0);
        srcb   : in  std_logic_vector(<$w2-1> downto 0);
        dst    : out std_logic_vector(<$w2-1> downto 0);
        clk    : in  std_logic);
end <$mname>;

architecture rtl of <$mname> is

begin

  process(clk)
  begin
    if (clk'event and clk='1') then
      if (cond = '1') then
        dst <= srca;
      else
        dst <= srcb;
      end if;
    end if;
  end process;

end rtl;
